package b4a.graph;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.graph", "b4a.graph.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.graph", "b4a.graph.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _progname = "";
public static String _progversion = "";
public static int _graphx0 = 0;
public static int _graphy0 = 0;
public static int _graphx1 = 0;
public static int _graphy1 = 0;
public static int _graphw = 0;
public static int _graphh = 0;
public static int _graphcolor = 0;
public static int _gridx0 = 0;
public static int _gridy0 = 0;
public static int _gridx1 = 0;
public static int _gridy1 = 0;
public static int _gridw = 0;
public static int _gridh = 0;
public static int _gridnbdivx = 0;
public static int _gridnbdivy = 0;
public static float _griddeltax = 0f;
public static float _griddeltay = 0f;
public static int _gridcolor = 0;
public static int _gridlinecolor = 0;
public static int _gridframecolor = 0;
public static int _curvenb = 0;
public static int _curvenbpoints = 0;
public static double[][] _curve = null;
public static int[] _curvelinecolor = null;
public static float[] _curvelinestroke = null;
public static String[] _curvename = null;
public static String[] _curveunit = null;
public static float _curvetextsize = 0f;
public static float _curvetextheight = 0f;
public static double _scalex = 0;
public static double _scaley = 0;
public static double _scalexdelta = 0;
public static double _scaleydelta = 0;
public static double _scalexmin = 0;
public static double _scaleymin = 0;
public static double _scalexmax = 0;
public static double _scaleymax = 0;
public static int _scaletextcolor = 0;
public static float _scaletextsize = 0f;
public static float _scaletextheight = 0f;
public static String _devicetype = "";
public static double _xhi = 0;
public static double _xlo = 0;
public static double _xx1 = 0;
public static double _yy1 = 0;
public static double _xx2 = 0;
public static double _yy2 = 0;
public anywheresoftware.b4a.objects.PanelWrapper _pnlgraph = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvsgraph = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rectgraph = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rectgrid = null;
public anywheresoftware.b4a.keywords.LayoutValues _lv = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 111;BA.debugLine="GetInputData";
_getinputdata();
 //BA.debugLineNum = 113;BA.debugLine="GraphInit";
_graphinit();
 //BA.debugLineNum = 114;BA.debugLine="CheckDeviceType";
_checkdevicetype();
 //BA.debugLineNum = 116;BA.debugLine="pnlGraph.Initialize(\"pnlGraph\")";
mostCurrent._pnlgraph.Initialize(mostCurrent.activityBA,"pnlGraph");
 //BA.debugLineNum = 117;BA.debugLine="Activity.AddView(pnlGraph, GraphX0, GraphY0, GraphW, GraphH)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlgraph.getObject()),_graphx0,_graphy0,_graphw,_graphh);
 //BA.debugLineNum = 119;BA.debugLine="cvsGraph.Initialize(pnlGraph)";
mostCurrent._cvsgraph.Initialize((android.view.View)(mostCurrent._pnlgraph.getObject()));
 //BA.debugLineNum = 120;BA.debugLine="CurveInit";
_curveinit();
 //BA.debugLineNum = 121;BA.debugLine="GridInit";
_gridinit();
 //BA.debugLineNum = 122;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 123;BA.debugLine="CurveValInit";
_curvevalinit();
 };
 //BA.debugLineNum = 125;BA.debugLine="ScaleInit";
_scaleinit();
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 145;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 147;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
int _i = 0;
 //BA.debugLineNum = 128;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 129;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 131;BA.debugLine="Activity.Title = ProgName & \" \" & ProgVersion";
mostCurrent._activity.setTitle((Object)(_progname+" "+_progversion));
 //BA.debugLineNum = 132;BA.debugLine="GraphClear";
_graphclear();
 //BA.debugLineNum = 133;BA.debugLine="GridDraw";
_griddraw();
 //BA.debugLineNum = 135;BA.debugLine="CurveDraw(0)";
_curvedraw((int)(0));
 //BA.debugLineNum = 138;BA.debugLine="PlotLine(xx1, 0,xx1, yy1,1)";
_plotline(_xx1,0,_xx1,_yy1,(int)(1));
 //BA.debugLineNum = 140;BA.debugLine="PlotLine(xx2, 0,xx2, yy2,1)";
_plotline(_xx2,0,_xx2,_yy2,(int)(1));
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _checkdevicetype() throws Exception{
 //BA.debugLineNum = 149;BA.debugLine="Sub CheckDeviceType";
 //BA.debugLineNum = 153;BA.debugLine="lv = GetDeviceLayoutValues";
mostCurrent._lv = anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA);
 //BA.debugLineNum = 156;BA.debugLine="DeviceType = \"Tablet 7\"";
_devicetype = "Tablet 7";
 //BA.debugLineNum = 158;BA.debugLine="Return";
if (true) return "";
 //BA.debugLineNum = 160;BA.debugLine="Select lv.Scale";
switch (BA.switchObjectToInt(mostCurrent._lv.Scale,(float)(2),(float)(1.5),(float)(1))) {
case 0:
 //BA.debugLineNum = 162;BA.debugLine="DeviceType = \"Smartphone 5\"";
_devicetype = "Smartphone 5";
 break;
case 1:
 //BA.debugLineNum = 164;BA.debugLine="If lv.Width > 1100 Then";
if (mostCurrent._lv.Width>1100) { 
 //BA.debugLineNum = 165;BA.debugLine="DeviceType = \"Tablet 7\"";
_devicetype = "Tablet 7";
 }else {
 //BA.debugLineNum = 167;BA.debugLine="DeviceType = \"Smartphone 3.5\"";
_devicetype = "Smartphone 3.5";
 };
 break;
case 2:
 //BA.debugLineNum = 170;BA.debugLine="If lv.Width > 1100 Then";
if (mostCurrent._lv.Width>1100) { 
 //BA.debugLineNum = 171;BA.debugLine="DeviceType = \"Tablet 10\"";
_devicetype = "Tablet 10";
 }else if(mostCurrent._lv.Width<600) { 
 //BA.debugLineNum = 173;BA.debugLine="DeviceType = \"Smartphone 3.5\"";
_devicetype = "Smartphone 3.5";
 }else {
 //BA.debugLineNum = 175;BA.debugLine="DeviceType = \"Tablet 7\"";
_devicetype = "Tablet 7";
 };
 break;
}
;
 //BA.debugLineNum = 178;BA.debugLine="End Sub";
return "";
}
public static String  _curvedraw(int _i) throws Exception{
int _n = 0;
float _d = 0f;
float _th = 0f;
float _x0 = 0f;
float _y0 = 0f;
float _x1 = 0f;
float _y1 = 0f;
float _textheight = 0f;
 //BA.debugLineNum = 362;BA.debugLine="Sub CurveDraw(i As Int)";
 //BA.debugLineNum = 364;BA.debugLine="Dim n  As Int";
_n = 0;
 //BA.debugLineNum = 365;BA.debugLine="Dim d, th, x0, y0, x1, y1 As Float";
_d = 0f;
_th = 0f;
_x0 = 0f;
_y0 = 0f;
_x1 = 0f;
_y1 = 0f;
 //BA.debugLineNum = 366;BA.debugLine="Dim TextHeight As Float";
_textheight = 0f;
 //BA.debugLineNum = 369;BA.debugLine="x0 = GridX0";
_x0 = (float)(_gridx0);
 //BA.debugLineNum = 370;BA.debugLine="y0 = GridY0 + (ScaleYMax - Curve(i, 0)) * ScaleY";
_y0 = (float)(_gridy0+(_scaleymax-_curve[_i][(int)(0)])*_scaley);
 //BA.debugLineNum = 371;BA.debugLine="d = GridW / CurveNbPoints";
_d = (float)(_gridw/(double)_curvenbpoints);
 //BA.debugLineNum = 372;BA.debugLine="For n = 1 To CurveNbPoints";
{
final double step217 = 1;
final double limit217 = _curvenbpoints;
for (_n = (int)(1); (step217 > 0 && _n <= limit217) || (step217 < 0 && _n >= limit217); _n += step217) {
 //BA.debugLineNum = 373;BA.debugLine="x1 = GridX0 + n * d";
_x1 = (float)(_gridx0+_n*_d);
 //BA.debugLineNum = 374;BA.debugLine="y1 = GridY0 + (ScaleYMax - Curve(i, n)) * ScaleY";
_y1 = (float)(_gridy0+(_scaleymax-_curve[_i][_n])*_scaley);
 //BA.debugLineNum = 375;BA.debugLine="cvsGraph.DrawLine(x0, y0, x1, y1, CurveLineColor(i), CurveLineStroke(i))";
mostCurrent._cvsgraph.DrawLine(_x0,_y0,_x1,_y1,_curvelinecolor[_i],_curvelinestroke[_i]);
 //BA.debugLineNum = 376;BA.debugLine="x0 = x1";
_x0 = _x1;
 //BA.debugLineNum = 377;BA.debugLine="y0 = y1";
_y0 = _y1;
 }
};
 //BA.debugLineNum = 381;BA.debugLine="TextHeight = cvsGraph.MeasureStringHeight(\"Ag\", Typeface.DEFAULT, CurveTextSize) + 2dip";
_textheight = (float)(mostCurrent._cvsgraph.MeasureStringHeight("Ag",anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_curvetextsize)+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)));
 //BA.debugLineNum = 384;BA.debugLine="y0 = GridY0 - TextHeight / 3";
_y0 = (float)(_gridy0-_textheight/(double)3);
 //BA.debugLineNum = 385;BA.debugLine="cvsGraph.DrawText(CurveName(i) & \" \" & CurveUnit(i), GridX0, y0 - i * TextHeight, Typeface.DEFAULT, CurveTextSize, CurveLineColor(i), \"LEFT\")";
mostCurrent._cvsgraph.DrawText(mostCurrent.activityBA,_curvename[_i]+" "+_curveunit[_i],(float)(_gridx0),(float)(_y0-_i*_textheight),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_curvetextsize,_curvelinecolor[_i],BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 386;BA.debugLine="End Sub";
return "";
}
public static String  _curveinit() throws Exception{
 //BA.debugLineNum = 331;BA.debugLine="Sub CurveInit";
 //BA.debugLineNum = 333;BA.debugLine="CurveLineColor(0) = Colors.Red";
_curvelinecolor[(int)(0)] = anywheresoftware.b4a.keywords.Common.Colors.Red;
 //BA.debugLineNum = 334;BA.debugLine="CurveLineColor(1) = Colors.Blue";
_curvelinecolor[(int)(1)] = anywheresoftware.b4a.keywords.Common.Colors.Blue;
 //BA.debugLineNum = 335;BA.debugLine="CurveLineColor(2) = Colors.RGB(10, 140, 0)";
_curvelinecolor[(int)(2)] = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(10),(int)(140),(int)(0));
 //BA.debugLineNum = 338;BA.debugLine="CurveLineStroke(0) = 3dip";
_curvelinestroke[(int)(0)] = (float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(3)));
 //BA.debugLineNum = 339;BA.debugLine="CurveLineStroke(1) = 2dip";
_curvelinestroke[(int)(1)] = (float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)));
 //BA.debugLineNum = 340;BA.debugLine="CurveLineStroke(2) = 1dip";
_curvelinestroke[(int)(2)] = (float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1)));
 //BA.debugLineNum = 343;BA.debugLine="CurveTextSize = 14";
_curvetextsize = (float)(14);
 //BA.debugLineNum = 359;BA.debugLine="CurveTextHeight = cvsGraph.MeasureStringHeight(\"Ag\", Typeface.DEFAULT, CurveTextSize) + 2dip";
_curvetextheight = (float)(mostCurrent._cvsgraph.MeasureStringHeight("Ag",anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_curvetextsize)+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)));
 //BA.debugLineNum = 360;BA.debugLine="End Sub";
return "";
}
public static String  _curvevalinit() throws Exception{
int _i = 0;
int _n = 0;
double _t = 0;
double[] _amplitude = null;
double[] _offset = null;
double[] _omega = null;
double _ymax = 0;
double _ymin = 0;
double _yt = 0;
double _t1 = 0;
double _t2 = 0;
 //BA.debugLineNum = 388;BA.debugLine="Sub CurveValInit";
 //BA.debugLineNum = 389;BA.debugLine="Dim i, n As Int";
_i = 0;
_n = 0;
 //BA.debugLineNum = 390;BA.debugLine="Dim t As Double";
_t = 0;
 //BA.debugLineNum = 391;BA.debugLine="Dim Amplitude(CurveNb) As Double";
_amplitude = new double[_curvenb];
;
 //BA.debugLineNum = 392;BA.debugLine="Dim Offset(CurveNb) As Double";
_offset = new double[_curvenb];
;
 //BA.debugLineNum = 393;BA.debugLine="Dim Omega(CurveNb) As Double";
_omega = new double[_curvenb];
;
 //BA.debugLineNum = 396;BA.debugLine="Amplitude(0) = 2.5";
_amplitude[(int)(0)] = 2.5;
 //BA.debugLineNum = 397;BA.debugLine="Amplitude(1) = 1.5";
_amplitude[(int)(1)] = 1.5;
 //BA.debugLineNum = 398;BA.debugLine="Amplitude(2) = .02";
_amplitude[(int)(2)] = .02;
 //BA.debugLineNum = 401;BA.debugLine="Offset(0) = 0";
_offset[(int)(0)] = 0;
 //BA.debugLineNum = 402;BA.debugLine="Offset(1) = 1";
_offset[(int)(1)] = 1;
 //BA.debugLineNum = 403;BA.debugLine="Offset(2) = -1";
_offset[(int)(2)] = -1;
 //BA.debugLineNum = 406;BA.debugLine="Omega(0)= 2.4 * cPI";
_omega[(int)(0)] = 2.4*anywheresoftware.b4a.keywords.Common.cPI;
 //BA.debugLineNum = 407;BA.debugLine="Omega(1)= 8 * cPI";
_omega[(int)(1)] = 8*anywheresoftware.b4a.keywords.Common.cPI;
 //BA.debugLineNum = 423;BA.debugLine="Dim ymax,ymin,yt As Double";
_ymax = 0;
_ymin = 0;
_yt = 0;
 //BA.debugLineNum = 425;BA.debugLine="ymax = -9999";
_ymax = -9999;
 //BA.debugLineNum = 427;BA.debugLine="ymin = 99999";
_ymin = 99999;
 //BA.debugLineNum = 429;BA.debugLine="Dim t1,t2 As Double";
_t1 = 0;
_t2 = 0;
 //BA.debugLineNum = 431;BA.debugLine="i=0";
_i = (int)(0);
 //BA.debugLineNum = 432;BA.debugLine="t=xlo";
_t = _xlo;
 //BA.debugLineNum = 433;BA.debugLine="For n = 0 To CurveNbPoints";
{
final double step248 = 1;
final double limit248 = _curvenbpoints;
for (_n = (int)(0); (step248 > 0 && _n <= limit248) || (step248 < 0 && _n >= limit248); _n += step248) {
 //BA.debugLineNum = 435;BA.debugLine="Curve(i, n) =  Fun(t)";
_curve[_i][_n] = _fun(_t);
 //BA.debugLineNum = 436;BA.debugLine="yt=Fun(t)";
_yt = _fun(_t);
 //BA.debugLineNum = 438;BA.debugLine="If yt  > ymax Then ymax = yt";
if (_yt>_ymax) { 
_ymax = _yt;};
 //BA.debugLineNum = 440;BA.debugLine="If yt  < ymin Then ymin = yt";
if (_yt<_ymin) { 
_ymin = _yt;};
 //BA.debugLineNum = 442;BA.debugLine="If n = CurveNbPoints  Then";
if (_n==_curvenbpoints) { 
 //BA.debugLineNum = 444;BA.debugLine="t1=n";
_t1 = _n;
 //BA.debugLineNum = 446;BA.debugLine="t2=Fun(t)";
_t2 = _fun(_t);
 //BA.debugLineNum = 448;BA.debugLine="t2=Fun(t)";
_t2 = _fun(_t);
 };
 //BA.debugLineNum = 452;BA.debugLine="t = t+1";
_t = _t+1;
 }
};
 //BA.debugLineNum = 458;BA.debugLine="CurveName(0) = \"Voltage\"";
_curvename[(int)(0)] = "Voltage";
 //BA.debugLineNum = 459;BA.debugLine="CurveUnit(0) = \"[V]\"";
_curveunit[(int)(0)] = "[V]";
 //BA.debugLineNum = 460;BA.debugLine="CurveName(1) = \"Current\"";
_curvename[(int)(1)] = "Current";
 //BA.debugLineNum = 461;BA.debugLine="CurveUnit(1) = \"[A]\"";
_curveunit[(int)(1)] = "[A]";
 //BA.debugLineNum = 462;BA.debugLine="CurveName(2) = \"Acceleration\"";
_curvename[(int)(2)] = "Acceleration";
 //BA.debugLineNum = 463;BA.debugLine="CurveUnit(2) = \"[m/s2]\"";
_curveunit[(int)(2)] = "[m/s2]";
 //BA.debugLineNum = 468;BA.debugLine="ScaleXMax = xhi";
_scalexmax = _xhi;
 //BA.debugLineNum = 469;BA.debugLine="ScaleXMin = xlo";
_scalexmin = _xlo;
 //BA.debugLineNum = 471;BA.debugLine="ScaleYMax = ymax";
_scaleymax = _ymax;
 //BA.debugLineNum = 472;BA.debugLine="ScaleYMin = ymin";
_scaleymin = _ymin;
 //BA.debugLineNum = 473;BA.debugLine="End Sub";
return "";
}
public static double  _fun(double _x) throws Exception{
 //BA.debugLineNum = 102;BA.debugLine="Sub Fun(x As Double) As Double";
 //BA.debugLineNum = 104;BA.debugLine="Return x*x+3";
if (true) return _x*_x+3;
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return 0;
}
public static String  _getinputdata() throws Exception{
 //BA.debugLineNum = 84;BA.debugLine="Sub GetInputData";
 //BA.debugLineNum = 86;BA.debugLine="xhi=10";
_xhi = 10;
 //BA.debugLineNum = 87;BA.debugLine="xlo=-10";
_xlo = -10;
 //BA.debugLineNum = 89;BA.debugLine="CurveNbPoints = xhi-xlo";
_curvenbpoints = (int)(_xhi-_xlo);
 //BA.debugLineNum = 91;BA.debugLine="xx1=2";
_xx1 = 2;
 //BA.debugLineNum = 93;BA.debugLine="yy1=Fun(xx1)";
_yy1 = _fun(_xx1);
 //BA.debugLineNum = 94;BA.debugLine="xx2=8";
_xx2 = 8;
 //BA.debugLineNum = 96;BA.debugLine="yy2=Fun(xx2)";
_yy2 = _fun(_xx2);
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 76;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 77;BA.debugLine="Dim pnlGraph As Panel					' Graph panel";
mostCurrent._pnlgraph = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 78;BA.debugLine="Dim cvsGraph As Canvas				' Graph canvas";
mostCurrent._cvsgraph = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 79;BA.debugLine="Dim rectGraph As Rect					' Graph rectangle";
mostCurrent._rectgraph = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 80;BA.debugLine="Dim rectGrid As Rect					' Grid rectangle";
mostCurrent._rectgrid = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 81;BA.debugLine="Dim lv As LayoutValues";
mostCurrent._lv = new anywheresoftware.b4a.keywords.LayoutValues();
 //BA.debugLineNum = 82;BA.debugLine="End Sub";
return "";
}
public static String  _graphclear() throws Exception{
 //BA.debugLineNum = 195;BA.debugLine="Sub GraphClear";
 //BA.debugLineNum = 197;BA.debugLine="cvsGraph.DrawRect(rectGraph, GraphColor, True, 1)";
mostCurrent._cvsgraph.DrawRect((android.graphics.Rect)(mostCurrent._rectgraph.getObject()),_graphcolor,anywheresoftware.b4a.keywords.Common.True,(float)(1));
 //BA.debugLineNum = 198;BA.debugLine="Activity.Invalidate";
mostCurrent._activity.Invalidate();
 //BA.debugLineNum = 199;BA.debugLine="End Sub";
return "";
}
public static String  _graphinit() throws Exception{
 //BA.debugLineNum = 180;BA.debugLine="Sub GraphInit";
 //BA.debugLineNum = 183;BA.debugLine="GraphX0 = 3%y";
_graphx0 = anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(3),mostCurrent.activityBA);
 //BA.debugLineNum = 184;BA.debugLine="GraphW = 100%x - 2 * GraphX0";
_graphw = (int)(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA)-2*_graphx0);
 //BA.debugLineNum = 185;BA.debugLine="GraphX1 = GraphX0 + GraphW";
_graphx1 = (int)(_graphx0+_graphw);
 //BA.debugLineNum = 187;BA.debugLine="GraphY0 = 3%y";
_graphy0 = anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(3),mostCurrent.activityBA);
 //BA.debugLineNum = 188;BA.debugLine="GraphH = 100%y - 2 * GraphY0";
_graphh = (int)(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-2*_graphy0);
 //BA.debugLineNum = 189;BA.debugLine="GraphY1 = GraphY0 + GraphH";
_graphy1 = (int)(_graphy0+_graphh);
 //BA.debugLineNum = 191;BA.debugLine="rectGraph.Initialize(0, 0, GraphW, GraphH)";
mostCurrent._rectgraph.Initialize((int)(0),(int)(0),_graphw,_graphh);
 //BA.debugLineNum = 192;BA.debugLine="GraphColor = Colors.White";
_graphcolor = anywheresoftware.b4a.keywords.Common.Colors.White;
 //BA.debugLineNum = 193;BA.debugLine="End Sub";
return "";
}
public static String  _griddraw() throws Exception{
int _i = 0;
float _x0 = 0f;
float _y0 = 0f;
 //BA.debugLineNum = 261;BA.debugLine="Sub GridDraw";
 //BA.debugLineNum = 263;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 264;BA.debugLine="Dim x0, y0 As Float";
_x0 = 0f;
_y0 = 0f;
 //BA.debugLineNum = 267;BA.debugLine="For i = 1 To GridNbDivX - 1";
{
final double step159 = 1;
final double limit159 = (int)(_gridnbdivx-1);
for (_i = (int)(1); (step159 > 0 && _i <= limit159) || (step159 < 0 && _i >= limit159); _i += step159) {
 //BA.debugLineNum = 268;BA.debugLine="x0 = GridX0 + i * GridDeltaX";
_x0 = (float)(_gridx0+_i*_griddeltax);
 //BA.debugLineNum = 269;BA.debugLine="cvsGraph.DrawLine(x0, GridY0, x0, GridY1, GridLineColor, 1)";
mostCurrent._cvsgraph.DrawLine(_x0,(float)(_gridy0),_x0,(float)(_gridy1),_gridlinecolor,(float)(1));
 }
};
 //BA.debugLineNum = 273;BA.debugLine="For i = 1 To GridNbDivY - 1";
{
final double step163 = 1;
final double limit163 = (int)(_gridnbdivy-1);
for (_i = (int)(1); (step163 > 0 && _i <= limit163) || (step163 < 0 && _i >= limit163); _i += step163) {
 //BA.debugLineNum = 274;BA.debugLine="y0 = GridY0 + i * GridDeltaY";
_y0 = (float)(_gridy0+_i*_griddeltay);
 //BA.debugLineNum = 275;BA.debugLine="cvsGraph.DrawLine(GridX0, y0, GridX1, y0, GridLineColor, 1)";
mostCurrent._cvsgraph.DrawLine((float)(_gridx0),_y0,(float)(_gridx1),_y0,_gridlinecolor,(float)(1));
 }
};
 //BA.debugLineNum = 279;BA.debugLine="cvsGraph.DrawRect(rectGrid, GridFrameColor, False, 1)";
mostCurrent._cvsgraph.DrawRect((android.graphics.Rect)(mostCurrent._rectgrid.getObject()),_gridframecolor,anywheresoftware.b4a.keywords.Common.False,(float)(1));
 //BA.debugLineNum = 282;BA.debugLine="ScaleYDraw";
_scaleydraw();
 //BA.debugLineNum = 283;BA.debugLine="ScaleXDraw";
_scalexdraw();
 //BA.debugLineNum = 286;BA.debugLine="Activity.Invalidate";
mostCurrent._activity.Invalidate();
 //BA.debugLineNum = 287;BA.debugLine="End Sub";
return "";
}
public static String  _gridinit() throws Exception{
 //BA.debugLineNum = 201;BA.debugLine="Sub GridInit";
 //BA.debugLineNum = 206;BA.debugLine="GridX0 = 2 * CurveTextHeight";
_gridx0 = (int)(2*_curvetextheight);
 //BA.debugLineNum = 207;BA.debugLine="GridW = GraphW - GridX0 - 1.2 * CurveTextHeight";
_gridw = (int)(_graphw-_gridx0-1.2*_curvetextheight);
 //BA.debugLineNum = 208;BA.debugLine="GridX1 = GridX0 + GridW";
_gridx1 = (int)(_gridx0+_gridw);
 //BA.debugLineNum = 211;BA.debugLine="GridY0 = 3.2 * CurveTextHeight";
_gridy0 = (int)(3.2*_curvetextheight);
 //BA.debugLineNum = 212;BA.debugLine="GridH = GraphH - GridY0 - 1.2 * CurveTextHeight";
_gridh = (int)(_graphh-_gridy0-1.2*_curvetextheight);
 //BA.debugLineNum = 213;BA.debugLine="GridY1 = GridY0 + GridH";
_gridy1 = (int)(_gridy0+_gridh);
 //BA.debugLineNum = 216;BA.debugLine="If lv.Width > lv.Height Then";
if (mostCurrent._lv.Width>mostCurrent._lv.Height) { 
 //BA.debugLineNum = 217;BA.debugLine="GridNbDivX = xhi-xlo";
_gridnbdivx = (int)(_xhi-_xlo);
 //BA.debugLineNum = 221;BA.debugLine="GridNbDivY = 6";
_gridnbdivy = (int)(6);
 }else {
 //BA.debugLineNum = 224;BA.debugLine="GridNbDivX = xhi-xlo";
_gridnbdivx = (int)(_xhi-_xlo);
 //BA.debugLineNum = 226;BA.debugLine="GridNbDivY = 12";
_gridnbdivy = (int)(12);
 };
 //BA.debugLineNum = 230;BA.debugLine="GridDeltaX = GridW / GridNbDivX";
_griddeltax = (float)(_gridw/(double)_gridnbdivx);
 //BA.debugLineNum = 231;BA.debugLine="GridDeltaY = GridH / GridNbDivY";
_griddeltay = (float)(_gridh/(double)_gridnbdivy);
 //BA.debugLineNum = 234;BA.debugLine="rectGrid.Initialize(GridX0, GridY0, GridX1, GridY1)";
mostCurrent._rectgrid.Initialize(_gridx0,_gridy0,_gridx1,_gridy1);
 //BA.debugLineNum = 237;BA.debugLine="GridColor = Colors.White";
_gridcolor = anywheresoftware.b4a.keywords.Common.Colors.White;
 //BA.debugLineNum = 238;BA.debugLine="GridLineColor = Colors.LightGray";
_gridlinecolor = anywheresoftware.b4a.keywords.Common.Colors.LightGray;
 //BA.debugLineNum = 239;BA.debugLine="GridFrameColor = Colors.Black";
_gridframecolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 241;BA.debugLine="ScaleTextColor = Colors.Black";
_scaletextcolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 244;BA.debugLine="ScaleTextSize = 12";
_scaletextsize = (float)(12);
 //BA.debugLineNum = 257;BA.debugLine="ScaleTextHeight = cvsGraph.MeasureStringHeight(\"Ag\", Typeface.DEFAULT, ScaleTextSize) + 2dip";
_scaletextheight = (float)(mostCurrent._cvsgraph.MeasureStringHeight("Ag",anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_scaletextsize)+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)));
 //BA.debugLineNum = 259;BA.debugLine="End Sub";
return "";
}
public static String  _plotline(double _x1location,double _y1location,double _x2location,double _y2location,int _i) throws Exception{
float _x1 = 0f;
float _y1 = 0f;
float _x2 = 0f;
float _y2 = 0f;
double _textwidth = 0;
float _textheight = 0f;
double _y0 = 0;
 //BA.debugLineNum = 475;BA.debugLine="Sub PlotLine(x1location As Double, y1location As Double,x2location As Double, y2location As Double, i As Int)";
 //BA.debugLineNum = 477;BA.debugLine="Dim    x1, y1, x2, y2 As Float";
_x1 = 0f;
_y1 = 0f;
_x2 = 0f;
_y2 = 0f;
 //BA.debugLineNum = 480;BA.debugLine="If x1location < ScaleXMin Then x1location=ScaleXMin";
if (_x1location<_scalexmin) { 
_x1location = _scalexmin;};
 //BA.debugLineNum = 481;BA.debugLine="If x2location < ScaleXMin Then x2location=ScaleXMin";
if (_x2location<_scalexmin) { 
_x2location = _scalexmin;};
 //BA.debugLineNum = 483;BA.debugLine="If x1location > ScaleXMax Then x1location=ScaleXMax";
if (_x1location>_scalexmax) { 
_x1location = _scalexmax;};
 //BA.debugLineNum = 484;BA.debugLine="If x2location > ScaleXMax Then x2location=ScaleXMax";
if (_x2location>_scalexmax) { 
_x2location = _scalexmax;};
 //BA.debugLineNum = 486;BA.debugLine="If y1location < ScaleYMin Then y1location=ScaleYMin";
if (_y1location<_scaleymin) { 
_y1location = _scaleymin;};
 //BA.debugLineNum = 487;BA.debugLine="If y2location < ScaleYMin Then y2location=ScaleYMin";
if (_y2location<_scaleymin) { 
_y2location = _scaleymin;};
 //BA.debugLineNum = 489;BA.debugLine="If y1location > ScaleYMax Then y1location=ScaleYMax";
if (_y1location>_scaleymax) { 
_y1location = _scaleymax;};
 //BA.debugLineNum = 490;BA.debugLine="If y2location > ScaleYMax Then y2location=ScaleYMax";
if (_y2location>_scaleymax) { 
_y2location = _scaleymax;};
 //BA.debugLineNum = 493;BA.debugLine="x1= GridX0+(x1location-ScaleXMin)*GridDeltaX";
_x1 = (float)(_gridx0+(_x1location-_scalexmin)*_griddeltax);
 //BA.debugLineNum = 497;BA.debugLine="y1 = GridY0 + (ScaleYMax - y1location) * ScaleY";
_y1 = (float)(_gridy0+(_scaleymax-_y1location)*_scaley);
 //BA.debugLineNum = 502;BA.debugLine="x2= GridX0+( x2location-ScaleXMin)*GridDeltaX";
_x2 = (float)(_gridx0+(_x2location-_scalexmin)*_griddeltax);
 //BA.debugLineNum = 507;BA.debugLine="y2 = GridY0 + (ScaleYMax - y2location) * ScaleY";
_y2 = (float)(_gridy0+(_scaleymax-_y2location)*_scaley);
 //BA.debugLineNum = 510;BA.debugLine="cvsGraph.DrawLine(x1, y1, x2, y2, CurveLineColor(i), CurveLineStroke(i))";
mostCurrent._cvsgraph.DrawLine(_x1,_y1,_x2,_y2,_curvelinecolor[_i],_curvelinestroke[_i]);
 //BA.debugLineNum = 514;BA.debugLine="Dim TextWidth As Double";
_textwidth = 0;
 //BA.debugLineNum = 515;BA.debugLine="Dim TextHeight As Float";
_textheight = 0f;
 //BA.debugLineNum = 517;BA.debugLine="TextHeight = cvsGraph.MeasureStringHeight(\"x\", Typeface.DEFAULT, 14) + 2dip";
_textheight = (float)(mostCurrent._cvsgraph.MeasureStringHeight("x",anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(14))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)));
 //BA.debugLineNum = 519;BA.debugLine="TextWidth = cvsGraph.MeasureStringWidth(\"x\", Typeface.DEFAULT, 14)";
_textwidth = mostCurrent._cvsgraph.MeasureStringWidth("x",anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(14));
 //BA.debugLineNum = 521;BA.debugLine="Dim y0 As Double";
_y0 = 0;
 //BA.debugLineNum = 523;BA.debugLine="y0 = y2  + TextHeight / 3";
_y0 = _y2+_textheight/(double)3;
 //BA.debugLineNum = 524;BA.debugLine="x1=x2-TextWidth/2";
_x1 = (float)(_x2-_textwidth/(double)2);
 //BA.debugLineNum = 527;BA.debugLine="cvsGraph.DrawText(\"x\"  , x1, y0 , Typeface.DEFAULT, 14, Colors.black, \"LEFT\")";
mostCurrent._cvsgraph.DrawText(mostCurrent.activityBA,"x",_x1,(float)(_y0),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(14),anywheresoftware.b4a.keywords.Common.Colors.Black,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 530;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 12;BA.debugLine="Dim ProgName As String				: ProgName = \"Graph\"";
_progname = "";
 //BA.debugLineNum = 12;BA.debugLine="Dim ProgName As String				: ProgName = \"Graph\"";
_progname = "Graph";
 //BA.debugLineNum = 13;BA.debugLine="Dim ProgVersion As String			: ProgVersion = \"V 1.0\"";
_progversion = "";
 //BA.debugLineNum = 13;BA.debugLine="Dim ProgVersion As String			: ProgVersion = \"V 1.0\"";
_progversion = "V 1.0";
 //BA.debugLineNum = 16;BA.debugLine="Dim GraphX0 As Int					' left position of the Graph";
_graphx0 = 0;
 //BA.debugLineNum = 17;BA.debugLine="Dim GraphY0 As Int					' top position of the Graph";
_graphy0 = 0;
 //BA.debugLineNum = 18;BA.debugLine="Dim GraphX1 As Int					' right position of the Graph";
_graphx1 = 0;
 //BA.debugLineNum = 19;BA.debugLine="Dim GraphY1 As Int					' bottom position of the Graph";
_graphy1 = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim GraphW As Int						' width of the Graph";
_graphw = 0;
 //BA.debugLineNum = 21;BA.debugLine="Dim GraphH As Int						' height of the Graph";
_graphh = 0;
 //BA.debugLineNum = 22;BA.debugLine="Dim GraphColor As Int				' Graph background color";
_graphcolor = 0;
 //BA.debugLineNum = 25;BA.debugLine="Dim GridX0 As Int						' left position of the Grid";
_gridx0 = 0;
 //BA.debugLineNum = 26;BA.debugLine="Dim GridY0 As Int						' top position of the Grid";
_gridy0 = 0;
 //BA.debugLineNum = 27;BA.debugLine="Dim GridX1 As Int						' right position of the Grid";
_gridx1 = 0;
 //BA.debugLineNum = 28;BA.debugLine="Dim GridY1 As Int						' bottom position of the Grid";
_gridy1 = 0;
 //BA.debugLineNum = 29;BA.debugLine="Dim GridW As Int						' width of the Grid";
_gridw = 0;
 //BA.debugLineNum = 30;BA.debugLine="Dim GridH As Int						' height of the Grid";
_gridh = 0;
 //BA.debugLineNum = 31;BA.debugLine="Dim GridNbDivX As Int				' number of Grid X divisions";
_gridnbdivx = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim GridNbDivY As Int				' number of Grid Y divisions";
_gridnbdivy = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim GridDeltaX As Float			' Grid X division";
_griddeltax = 0f;
 //BA.debugLineNum = 34;BA.debugLine="Dim GridDeltaY As Float			' Grid Y division";
_griddeltay = 0f;
 //BA.debugLineNum = 35;BA.debugLine="Dim GridColor As Int				' Grid background color";
_gridcolor = 0;
 //BA.debugLineNum = 36;BA.debugLine="Dim GridLineColor As Int		' Grid line color";
_gridlinecolor = 0;
 //BA.debugLineNum = 37;BA.debugLine="Dim GridFrameColor As Int		' Grid frame color";
_gridframecolor = 0;
 //BA.debugLineNum = 40;BA.debugLine="Dim CurveNb As Int					' number of curves";
_curvenb = 0;
 //BA.debugLineNum = 41;BA.debugLine="CurveNb = 3";
_curvenb = (int)(3);
 //BA.debugLineNum = 42;BA.debugLine="Dim CurveNbPoints As Int		' number of points in the curve";
_curvenbpoints = 0;
 //BA.debugLineNum = 43;BA.debugLine="CurveNbPoints = 20";
_curvenbpoints = (int)(20);
 //BA.debugLineNum = 47;BA.debugLine="Dim Curve(CurveNb, CurveNbPoints + 1) As Double";
_curve = new double[_curvenb][];
{
int d0 = _curve.length;
int d1 = (int)(_curvenbpoints+1);
for (int i0 = 0;i0 < d0;i0++) {
_curve[i0] = new double[d1];
}
}
;
 //BA.debugLineNum = 48;BA.debugLine="Dim CurveLineColor(CurveNb) As Int";
_curvelinecolor = new int[_curvenb];
;
 //BA.debugLineNum = 49;BA.debugLine="Dim CurveLineStroke(CurveNb) As Float";
_curvelinestroke = new float[_curvenb];
;
 //BA.debugLineNum = 50;BA.debugLine="Dim CurveName(CurveNb) As String";
_curvename = new String[_curvenb];
java.util.Arrays.fill(_curvename,"");
 //BA.debugLineNum = 51;BA.debugLine="Dim CurveUnit(CurveNb) As String";
_curveunit = new String[_curvenb];
java.util.Arrays.fill(_curveunit,"");
 //BA.debugLineNum = 52;BA.debugLine="Dim CurveTextSize As Float";
_curvetextsize = 0f;
 //BA.debugLineNum = 53;BA.debugLine="Dim CurveTextHeight As Float";
_curvetextheight = 0f;
 //BA.debugLineNum = 55;BA.debugLine="Dim ScaleX As Double					' X scale, ratio pixels / physic unit";
_scalex = 0;
 //BA.debugLineNum = 56;BA.debugLine="Dim ScaleY As Double					' Y scale, ratio pixels / physic unit";
_scaley = 0;
 //BA.debugLineNum = 57;BA.debugLine="Dim ScaleXDelta As Double			' width of one X division in physic units";
_scalexdelta = 0;
 //BA.debugLineNum = 58;BA.debugLine="Dim ScaleYDelta As Double			' width of one Y division in physic units";
_scaleydelta = 0;
 //BA.debugLineNum = 59;BA.debugLine="Dim ScaleXMin As Double				' min X physical scale value";
_scalexmin = 0;
 //BA.debugLineNum = 60;BA.debugLine="Dim ScaleYMin As Double				' min Y physical scale value";
_scaleymin = 0;
 //BA.debugLineNum = 61;BA.debugLine="Dim ScaleXMax As Double				' max X physical scale value";
_scalexmax = 0;
 //BA.debugLineNum = 62;BA.debugLine="Dim ScaleYMax As Double				' max Y physical scale value";
_scaleymax = 0;
 //BA.debugLineNum = 63;BA.debugLine="Dim ScaleTextColor As Int";
_scaletextcolor = 0;
 //BA.debugLineNum = 64;BA.debugLine="Dim ScaleTextSize As Float";
_scaletextsize = 0f;
 //BA.debugLineNum = 65;BA.debugLine="Dim ScaleTextHeight As Float";
_scaletextheight = 0f;
 //BA.debugLineNum = 67;BA.debugLine="Dim DeviceType As String";
_devicetype = "";
 //BA.debugLineNum = 70;BA.debugLine="Dim xhi,xlo As Double";
_xhi = 0;
_xlo = 0;
 //BA.debugLineNum = 72;BA.debugLine="Dim xx1,yy1,xx2,yy2 As Double";
_xx1 = 0;
_yy1 = 0;
_xx2 = 0;
_yy2 = 0;
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _scaleinit() throws Exception{
 //BA.debugLineNum = 320;BA.debugLine="Sub ScaleInit";
 //BA.debugLineNum = 324;BA.debugLine="ScaleXDelta = (ScaleXMax-ScaleXMin) / GridNbDivX";
_scalexdelta = (_scalexmax-_scalexmin)/(double)_gridnbdivx;
 //BA.debugLineNum = 325;BA.debugLine="ScaleX = GridW / (ScaleXMax - ScaleXMin)";
_scalex = _gridw/(double)(_scalexmax-_scalexmin);
 //BA.debugLineNum = 327;BA.debugLine="ScaleYDelta = (ScaleYMax - ScaleYMin) / GridNbDivY";
_scaleydelta = (_scaleymax-_scaleymin)/(double)_gridnbdivy;
 //BA.debugLineNum = 328;BA.debugLine="ScaleY = GridH / (ScaleYMax - ScaleYMin)";
_scaley = _gridh/(double)(_scaleymax-_scaleymin);
 //BA.debugLineNum = 329;BA.debugLine="End Sub";
return "";
}
public static String  _scalexdraw() throws Exception{
int _i = 0;
String _txt = "";
float _x = 0f;
float _y = 0f;
 //BA.debugLineNum = 289;BA.debugLine="Sub ScaleXDraw";
 //BA.debugLineNum = 291;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 292;BA.debugLine="Dim txt As String";
_txt = "";
 //BA.debugLineNum = 293;BA.debugLine="Dim x, y As Float";
_x = 0f;
_y = 0f;
 //BA.debugLineNum = 295;BA.debugLine="y = GridY1 + ScaleTextHeight";
_y = (float)(_gridy1+_scaletextheight);
 //BA.debugLineNum = 296;BA.debugLine="For i = 0 To GridNbDivX";
{
final double step177 = 1;
final double limit177 = _gridnbdivx;
for (_i = (int)(0); (step177 > 0 && _i <= limit177) || (step177 < 0 && _i >= limit177); _i += step177) {
 //BA.debugLineNum = 298;BA.debugLine="txt = NumberFormat2((ScaleXMin + i * ScaleXDelta), 0, 1, 1, True)";
_txt = anywheresoftware.b4a.keywords.Common.NumberFormat2((_scalexmin+_i*_scalexdelta),(int)(0),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 299;BA.debugLine="x = GridX0 + i * GridDeltaX";
_x = (float)(_gridx0+_i*_griddeltax);
 //BA.debugLineNum = 300;BA.debugLine="cvsGraph.DrawText(txt, x, y, Typeface.DEFAULT, ScaleTextSize, ScaleTextColor, \"CENTER\")";
mostCurrent._cvsgraph.DrawText(mostCurrent.activityBA,_txt,_x,_y,anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_scaletextsize,_scaletextcolor,BA.getEnumFromString(android.graphics.Paint.Align.class,"CENTER"));
 }
};
 //BA.debugLineNum = 302;BA.debugLine="End Sub";
return "";
}
public static String  _scaleydraw() throws Exception{
int _i = 0;
String _txt = "";
float _x = 0f;
float _y = 0f;
 //BA.debugLineNum = 304;BA.debugLine="Sub ScaleYDraw";
 //BA.debugLineNum = 306;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 307;BA.debugLine="Dim txt As String";
_txt = "";
 //BA.debugLineNum = 308;BA.debugLine="Dim x, y As Float";
_x = 0f;
_y = 0f;
 //BA.debugLineNum = 310;BA.debugLine="x = GridX0 - ScaleTextHeight / 3";
_x = (float)(_gridx0-_scaletextheight/(double)3);
 //BA.debugLineNum = 311;BA.debugLine="For i = 0 To GridNbDivY";
{
final double step188 = 1;
final double limit188 = _gridnbdivy;
for (_i = (int)(0); (step188 > 0 && _i <= limit188) || (step188 < 0 && _i >= limit188); _i += step188) {
 //BA.debugLineNum = 314;BA.debugLine="txt = NumberFormat2((ScaleYMax - i * ScaleYDelta), 0, 1, 1, True)";
_txt = anywheresoftware.b4a.keywords.Common.NumberFormat2((_scaleymax-_i*_scaleydelta),(int)(0),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 315;BA.debugLine="y = GridY0 + ScaleTextHeight/3 + i * GridDeltaY";
_y = (float)(_gridy0+_scaletextheight/(double)3+_i*_griddeltay);
 //BA.debugLineNum = 316;BA.debugLine="cvsGraph.DrawText(txt, x, y, Typeface.DEFAULT, ScaleTextSize, ScaleTextColor, \"RIGHT\")";
mostCurrent._cvsgraph.DrawText(mostCurrent.activityBA,_txt,_x,_y,anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,_scaletextsize,_scaletextcolor,BA.getEnumFromString(android.graphics.Paint.Align.class,"RIGHT"));
 }
};
 //BA.debugLineNum = 318;BA.debugLine="End Sub";
return "";
}
}
